## ufo-core 0.16.0.52.gbd831ab

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

if (POLICY CMP0053)
cmake_policy(SET CMP0053 OLD)
endif ()

if (POLICY CMP0054)
cmake_policy(SET CMP0054 OLD)
endif ()

project(ufo C)

set(TARNAME "libufo")

set(UFO_NAME                "libufo")
set(UFO_DESCRIPTION         "UFO high-speed image processing core library")
set(UFO_DESCRIPTION_SUMMARY "UFO high-speed image processing core library")

#{{{ Library version
set(UFO_VERSION_MAJOR "1")
set(UFO_VERSION_MINOR "0")
set(UFO_VERSION_PATCH "0")
set(UFO_VERSION "${UFO_VERSION_MAJOR}.${UFO_VERSION_MINOR}.${UFO_VERSION_PATCH}")
set(UFO_GIR_VERSION "${UFO_VERSION_MAJOR}.0")
#}}}
#{{{ CMake
enable_testing()

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/common/cmake")

include(GNUInstallDirs)
include(PkgConfigVars)

set(CMAKE_INSTALL_INCLUDEDIR    "${CMAKE_INSTALL_INCLUDEDIR}/ufo-${UFO_VERSION_MAJOR}")
set(CMAKE_INSTALL_KERNELDIR     "${CMAKE_INSTALL_DATAROOTDIR}/ufo")
set(CMAKE_INSTALL_GIRDIR        "${CMAKE_INSTALL_DATAROOTDIR}/gir-1.0")
set(CMAKE_INSTALL_PLUGINDIR     "${CMAKE_INSTALL_LIBDIR}/ufo")
set(CMAKE_INSTALL_TYPELIBDIR    "${CMAKE_INSTALL_LIBDIR}/girepository-1.0")
set(CMAKE_INSTALL_PKGCONFIGDIR  "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

if (APPLE)
    set(CMAKE_MACOSX_RPATH      "ON")
    set(CMAKE_INSTALL_RPATH     "${CMAKE_INSTALL_PREFIX}/lib")
endif()

#}}}
#{{{ Options
option(WITH_TESTS "Build test suite" ON)
option(WITH_DEPRECATED_OPENCL_1_1_API "Build with deprecated OpenCL 1.1 API" ON)

if (WITH_DEPRECATED_OPENCL_1_1_API)
    add_definitions ("-DCL_USE_DEPRECATED_OPENCL_1_1_APIS")
endif ()
#}}}
#{{{ Dependencies
set(PKG_GLIB2_MIN_REQUIRED "2.38")
set(PKG_JSON_GLIB_MIN_REQUIRED "0.10.0")

find_package(OpenCL REQUIRED)
find_package(PkgConfig REQUIRED)

pkg_check_modules(GLIB2 glib-2.0>=${PKG_GLIB2_MIN_REQUIRED} REQUIRED)
pkg_check_modules(GOBJECT2 gobject-2.0>=${PKG_GLIB2_MIN_REQUIRED} REQUIRED)
pkg_check_modules(GMODULE2 gmodule-2.0>=${PKG_GLIB2_MIN_REQUIRED} REQUIRED)
pkg_check_modules(GTHREAD2 gthread-2.0>=${PKG_GLIB2_MIN_REQUIRED} REQUIRED)
pkg_check_modules(GIO2 gio-2.0>=${PKG_GLIB2_MIN_REQUIRED} REQUIRED)
pkg_check_modules(JSON_GLIB json-glib-1.0>=${PKG_JSON_GLIB_MIN_REQUIRED} REQUIRED)
pkg_check_modules(PYTHON python3-embed)

set(GLIB_VERSION_MIN_REQUIRED "GLIB_VERSION_2_38")
set(GLIB_VERSION_MAX_ALLOWED "GLIB_VERSION_2_38")
set(CL_TARGET_OPENCL_VERSION "120")

set(UFOCORE_DEPS
    m
    ${OpenCL_LIBRARIES}
    ${GLIB2_LIBRARIES}
    ${GOBJECT2_LIBRARIES}
    ${GMODULE2_LIBRARIES}
    ${GTHREAD2_LIBRARIES}
    ${GIO2_LIBRARIES}
    ${JSON_GLIB_LIBRARIES})

set (UFOCORE_DEPS_LIBDIR
    ${GLIB2_LIBRARY_DIRS}
    ${JSON_GLIB_LIBRARY_DIRS})


if (NOT PYTHON_FOUND)
    pkg_check_modules(PYTHON python3)
    if (NOT PYTHON_FOUND)
        pkg_check_modules(PYTHON python)
    endif ()
endif ()

if (PYTHON_FOUND)
    option(WITH_PYTHON "Enable Python multithreading support" ON)

    if (WITH_PYTHON)
        include_directories(${PYTHON_INCLUDE_DIRS})
        list(APPEND UFOCORE_DEPS ${PYTHON_LIBRARIES})
	list(APPEND UFOCORE_DEPS_LIBDIR ${PYTHON_LIBDIR})
    endif ()
endif()

#{{{ Link dirs of dependencies
link_directories(${UFOCORE_DEPS_LIBDIR})
#}}}
#{{{ Add include directories
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${GLIB2_INCLUDE_DIRS}
    ${GIO2_INCLUDE_DIRS}
    ${OpenCL_INCLUDE_DIRS}
    ${JSON_GLIB_INCLUDE_DIRS})
#}}}
#}}}
#{{{ Definitions
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -Wextra -fPIC -Wno-unused-parameter -Wno-deprecated-declarations")

add_definitions(-DG_LOG_DOMAIN=\"Ufo\"
                -D_FILE_OFFSET_BITS=64)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/config.h)
#}}}
#{{{ Subdirectories
add_subdirectory(ufo)
## Since sphinx is somehow unable to perform this part of the compilation on my system :
##add_subdirectory(docs)
add_subdirectory(bin)

if (WITH_TESTS)
    add_subdirectory(tests)
endif()
#}}}

=== meson_options.txt ===
option('gtk_doc',
    type: 'boolean', value: false,
    description: 'Build API references (requires gtk-doc)')

option('introspection',
    type: 'boolean', value: true,
    description: 'Build introspection data (requires gobject-introspection)')

option('bashcompletiondir',
    type: 'string',
    description: 'directory for bash complection scripts ["no" disables]')

=== bin/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#{{{ Binaries
add_executable(ufo-launch ufo-launch.c)
add_executable(ufo-query ufo-query.c)
add_executable(ufo-runjson ufo-runjson.c)

target_link_libraries(ufo-launch ufo)
target_link_libraries(ufo-query ufo)
target_link_libraries(ufo-runjson ufo)

install(TARGETS ufo-launch ufo-query ufo-runjson
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/ufo-prof
        DESTINATION ${CMAKE_INSTALL_BINDIR})

option(INSTALL_COMPLETION "Install Bash completion script" OFF)

if (INSTALL_COMPLETION)
    pkg_check_variable(bash-completion completionsdir)

    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/ufo-launch
            DESTINATION ${BASH_COMPLETION_COMPLETIONSDIR}
            OPTIONAL)
endif()
#}}}
#{{{ ufo-mkfilter
set(CMAKE_INSTALL_TEMPLATEDIR "${CMAKE_INSTALL_FULL_DATADIR}/ufo/templates")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ufo-mkfilter.in
               ${CMAKE_CURRENT_BINARY_DIR}/ufo-mkfilter
               @ONLY IMMEDIATE)

file(GLOB templates "templates/*.in")

install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/ufo-mkfilter
        DESTINATION ${CMAKE_INSTALL_BINDIR})

install(FILES ${templates}
        DESTINATION ${CMAKE_INSTALL_TEMPLATEDIR})
#}}}

=== ufo/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#{{{ sources
set(ufocore_SRCS
    ufo-priv.c
    ufo-base-scheduler.c
    ufo-copy-task.c
    ufo-buffer.c
    ufo-copyable-iface.c
    ufo-cpu-node.c
    ufo-dummy-task.c
    ufo-fixed-scheduler.c
    ufo-gpu-node.c
    ufo-graph.c
    ufo-group.c
    ufo-group-scheduler.c
    ufo-input-task.c
    ufo-local-scheduler.c
    ufo-method-iface.c
    ufo-node.c
    ufo-output-task.c
    ufo-plugin-manager.c
    ufo-profiler.c
    ufo-processor.c
    ufo-resources.c
    ufo-scheduler.c
    ufo-task-iface.c
    ufo-task-graph.c
    ufo-task-node.c
    ufo-transform-iface.c
    ufo-two-way-queue.c
    ufo-basic-ops.c
    )
#}}}
#{{{ headers
set(ufocore_HDRS
    ufo-base-scheduler.h
    ufo-copy-task.h
    ufo-buffer.h
    ufo-copyable-iface.h
    ufo-cpu-node.h
    ufo-dummy-task.h
    ufo-fixed-scheduler.h
    ufo-gpu-node.h
    ufo-graph.h
    ufo-group.h
    ufo-group-scheduler.h
    ufo-input-task.h
    ufo-local-scheduler.h
    ufo-method-iface.h
    ufo-node.h
    ufo-output-task.h
    ufo-plugin-manager.h
    ufo-profiler.h
    ufo-processor.h
    ufo-resources.h
    ufo-scheduler.h
    ufo-task-iface.h
    ufo-task-graph.h
    ufo-task-node.h
    ufo-transform-iface.h
    ufo-two-way-queue.h
    ufo-basic-ops.h
    )
#}}}
#{{{ libufo

add_definitions(-DUFO_COMPILATION)

if(CMAKE_BUILD_TYPE MATCHES "Release")
    add_definitions(-DG_DISABLE_ASSERT)
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(ufo SHARED ${ufocore_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.c)

set_target_properties(ufo PROPERTIES
    VERSION ${UFO_VERSION}
    SOVERSION ${UFO_VERSION_MAJOR})

target_link_libraries(ufo ${UFOCORE_DEPS})

#{{{ install target
install(TARGETS ufo
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(FILES ${ufocore_HDRS}
              ${CMAKE_CURRENT_SOURCE_DIR}/ufo.h
              ${CMAKE_CURRENT_SOURCE_DIR}/ufo-cl.h
              ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.h
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ufo)

install(FILES ufo-basic-ops.cl
        DESTINATION ${CMAKE_INSTALL_KERNELDIR})
#}}}
#}}}
#{{{ glib-mkenums
find_program(GLIB2_MKENUMS glib-mkenums REQUIRED)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.h
    COMMAND ${GLIB2_MKENUMS}
    ARGS
        --template ufo-enums.h.template
        ${ufocore_HDRS} > ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.h
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${ufocore_HDRS}
            ${CMAKE_CURRENT_SOURCE_DIR}/ufo-enums.h.template
)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.c
    COMMAND ${GLIB2_MKENUMS}
    ARGS
        --template ufo-enums.c.template
        ${ufocore_HDRS} > ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.c
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${ufocore_HDRS} ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.h
            ${CMAKE_CURRENT_SOURCE_DIR}/ufo-enums.c.template
)
#}}}
#{{{ GObject introspection
pkg_check_modules(GOBJECT_INTROSPECTION gobject-introspection-1.0)

if (GOBJECT_INTROSPECTION_FOUND)
    option(WITH_GIR "Build introspection files" ON)

    if (WITH_GIR)
        pkg_check_variable(gobject-introspection-1.0 g_ir_scanner)
        pkg_check_variable(gobject-introspection-1.0 g_ir_compiler)

        set(GIR_PREFIX "Ufo-${UFO_GIR_VERSION}")
        set(GIR_XML "${GIR_PREFIX}.gir")
        set(GIR_TYPELIB "${GIR_PREFIX}.typelib")
        set(_gir_input)

        foreach(_src ${ufocore_SRCS} ${ufocore_HDRS})
            list(APPEND _gir_input "${CMAKE_CURRENT_SOURCE_DIR}/${_src}")
        endforeach()

        add_custom_command(OUTPUT ${GIR_XML}
            COMMAND ${GOBJECT_INTROSPECTION_1.0_G_IR_SCANNER}
                    --namespace=Ufo
                    --nsversion=${UFO_GIR_VERSION}
                    --library=ufo
                    --no-libtool
                    --include=GObject-2.0
                    --include=GModule-2.0
                    --include=GLib-2.0
                    --include=Json-1.0
                    -I${OPENCL_INCLUDE_DIRS}
                    -I${JSON_GLIB_INCLUDE_DIRS}
                    -I${CMAKE_CURRENT_SOURCE_DIR}/..
                    -DUFO_COMPILATION
                    --output ${GIR_XML}
                    --warn-all
                    --quiet
                    ${_gir_input}
            DEPENDS ${ufocore_SRCS}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

        add_custom_command(OUTPUT ${GIR_TYPELIB}
            COMMAND ${GOBJECT_INTROSPECTION_1.0_G_IR_COMPILER}
                    -o ${GIR_TYPELIB}
                    ${GIR_XML}
            DEPENDS ${GIR_XML}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

        add_custom_target(gir ALL DEPENDS ${GIR_XML} ${GIR_TYPELIB})
        add_dependencies(gir ufo)

        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${GIR_XML}
                DESTINATION ${CMAKE_INSTALL_GIRDIR})

        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${GIR_TYPELIB}
                DESTINATION ${CMAKE_INSTALL_TYPELIBDIR})
    endif()
endif()
#}}}
#{{{ gtk-doc
pkg_check_modules(GTK_DOC gtk-doc)

if(GTK_DOC_FOUND)
    option(WITH_GTK_DOC "Build API reference" ON)
    if (WITH_GTK_DOC)
        find_program(GTK_DOC_SCAN gtkdoc-scan REQUIRED)
        find_program(GTK_DOC_SCANGOBJ gtkdoc-scangobj REQUIRED)
        find_program(GTK_DOC_MKDB gtkdoc-mkdb REQUIRED)
        find_program(GTK_DOC_MKHTML gtkdoc-mkhtml REQUIRED)

        set(docs_dir "${CMAKE_CURRENT_BINARY_DIR}/../docs")
        set(docs_out "${docs_dir}/reference")
        set(docs_xml_in "${CMAKE_CURRENT_SOURCE_DIR}/../docs/Ufo-docs.xml")
        set(docs_xml_out "${docs_out}/Ufo-docs.xml")

        set(GTK_DOC_CFLAGS)
        set(GTK_DOC_LDFLAGS)

        get_directory_property(_current_include_dirs INCLUDE_DIRECTORIES)

        foreach(_incl ${_current_include_dirs})
            set(GTK_DOC_CFLAGS "-I${_incl} ${GTK_DOC_CFLAGS}")
        endforeach()

        foreach(_lib ${UFOCORE_DEPS})
            if (NOT ${_lib} MATCHES "^[/]")
                set(GTK_DOC_LDFLAGS "-l${_lib} ${GTK_DOC_LDFLAGS}")
            endif()
        endforeach()

        get_directory_property(_current_link_dirs LINK_DIRECTORIES)

        foreach(_linkdir ${_current_link_dirs})
            set(GTK_DOC_LDFLAGS "-L${_linkdir} ${GTK_DOC_LDFLAGS}")
        endforeach()

        configure_file("${CMAKE_CURRENT_SOURCE_DIR}/../docs/scangobj.sh.in" "${docs_out}/scangobj.sh")

        add_custom_target(docbook)
        add_custom_command(TARGET docbook PRE_BUILD
                           COMMAND ${CMAKE_COMMAND} -E
                                   copy ${docs_xml_in} ${docs_xml_out}
                                   DEPENDS ${docs_xml_out})

        add_custom_command(OUTPUT ${docs_out}/Ufo-decl.txt
            COMMAND ${GTK_DOC_SCAN}
                    --module=Ufo
                    --source-dir=${CMAKE_CURRENT_SOURCE_DIR}
                    --ignore-headers="${docs_ignore_headers}"
            DEPENDS ufo
            COMMENT "Running gtkdoc-scan"
            WORKING_DIRECTORY ${docs_out})

        add_custom_command(OUTPUT ${docs_out}/Ufo.args
            COMMAND sh scangobj.sh
            DEPENDS ufo ${docs_out}/Ufo-decl.txt
            COMMENT "Running gtkdoc-scangobj"
            WORKING_DIRECTORY ${docs_out})

        add_custom_command(OUTPUT ${docs_out}/sgml.stamp
            COMMAND ${GTK_DOC_MKDB}
                    --module=Ufo
                    --source-dir=${CMAKE_CURRENT_SOURCE_DIR}
                    --sgml-mode
                    --output-format=xml
            DEPENDS ufo ${docs_out}/Ufo.args
            COMMENT "Running gtkdoc-mkdb"
            WORKING_DIRECTORY ${docs_out})

        add_custom_command(OUTPUT ${docs_dir}/html.stamp
            COMMAND ${GTK_DOC_MKHTML}
                    --path="${CMAKE_CURRENT_BINARY_DIR}/../docs/reference"
                    Ufo
                    ${docs_xml_out}
            DEPENDS ufo ${docs_out}/sgml.stamp docbook
            COMMENT "Running gtkdoc-mkhtml"
            WORKING_DIRECTORY ${docs_out})

        add_custom_target(reference ALL DEPENDS ${docs_dir}/html.stamp)

        install(DIRECTORY ${docs_out}/
                DESTINATION ${CMAKE_INSTALL_DATADIR}/gtk-doc/html/Ufo
                FILES_MATCHING REGEX ".*\\.(html|png|devhelp2|css)$"
                PATTERN "xml" EXCLUDE)
    endif()
endif(GTK_DOC_FOUND)
#}}}
#{{{ pkg-config
# FIXME: inside the ufo.pc.in we should set the lib names that we found out, not
# hard coded values
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ufo.pc.in"
               "${CMAKE_CURRENT_BINARY_DIR}/ufo.pc" @ONLY IMMEDIATE)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ufo.pc
        DESTINATION ${CMAKE_INSTALL_PKGCONFIGDIR})
#}}}

=== tests/unit/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(TEST_SRCS
    test-suite.c
    test-buffer.c
    test-graph.c
    test-node.c
    test-profiler.c
    )

set(SUITE_BIN "test-suite")

add_executable(${SUITE_BIN} ${TEST_SRCS})

target_link_libraries(${SUITE_BIN} ufo m ${UFOCORE_DEPS})

add_test(${SUITE_BIN} ${SUITE_BIN})

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/gtester.xsl"
               "${CMAKE_CURRENT_BINARY_DIR}/gtester.xsl"
               @ONLY IMMEDIATE)

=== debian/changelog ===
ufo-core (0.16.0.52.gbd831ab-1build7) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:14:51 +1100

ufo-core (0.16.0.52.gbd831ab-1build6) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:44:25 +0000

ufo-core (0.16.0.52.gbd831ab-1build5) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Mar 2024 21:15:47 +0100

ufo-core (0.16.0.52.gbd831ab-1build4) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 20 Jan 2024 09:13:07 +0000

ufo-core (0.16.0.52.gbd831ab-1build3) lunar; urgency=medium

  * No-change rebuild with Python 3.11 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 26 Dec 2022 10:06:53 +0000

ufo-core (0.16.0.52.gbd831ab-1build2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 14 Jan 2022 15:08:44 +0000

ufo-core (0.16.0.52.gbd831ab-1build1) hirsute; urgency=medium

  * No-change rebuild to build with python3.9 as default.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 19 Nov 2020 20:21:22 +0100

ufo-core (0.16.0.52.gbd831ab-1) unstable; urgency=medium

  * Uploading into unstable

 -- Serge Cohen <serge1cohen@free.fr>  Wed, 14 Oct 2020 11:46:05 +0200

ufo-core (0.16.0.52.gbd831ab-1~exp1) experimental; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 10 to 12.
  * Fix day-of-week for changelog entry 0.11.1-1.

  [ Serge Cohen ]
  * New upstream version 0.16.0.52.gbd831ab
  * d/patches: Removed
  * d/control: Bumped Standard-Version 4.5.0 (nothing to do)
  * d/control: Removed ufod package
  * d/control: Removed systemd from Build-Depends
  * d/watch: Trying to get upstream from serge's gitlab repo
  * d/salsa-ci.yml: -> recipes/debian.yml@salsa-ci-team/pipeline

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 01 Oct 2020 15:43:37 +0200

=== debian/control ===
Source: ufo-core
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Picca Frédéric-Emmanuel <picca@debian.org>,
 Serge Cohen <serge1cohen@free.fr>,
 Alexandre Marie <alexandre.marie@synchrotron-soleil.fr>
Section: libs
Priority: optional
Build-Depends: asciidoc,
               bash-completion,
               cmake,
               debhelper-compat (= 12),
               dh-python,
               gobject-introspection,
               gtk-doc-tools,
               libgirepository1.0-dev,
               libglib2.0-dev,
               libjson-glib-dev,
               libzmq3-dev,
               ocl-icd-opencl-dev,
               python3-dev,
               python3-sphinx,
               python3-sphinx-rtd-theme,
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/ufo-core
Vcs-Git: https://salsa.debian.org/science-team/ufo-core.git
Homepage: http://ufo.kit.edu/

Package: gir1.2-ufo-1.0
Architecture: any
Multi-Arch: same
Section: introspection
Depends: ${gir:Depends}, ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Library for high-performance, GPU-based computing - gir binding
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package can be used by other packages using the GIRepository
 format to generate dynamic bindings.

Package: libufo1
Architecture: any
Multi-Arch: same
Section: libs
Depends: libufo-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Library for high-performance, GPU-based computing - runtime
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package provides the runtime for libufo.

Package: libufo-bin
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Suggests: ufo-core-doc
Description: Library for high-performance, GPU-based computing - tools
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package contains binaries to run JSON descriptions of task graphs.

Package: libufo-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Library for high-performance, GPU-based computing - data
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package provides the openCL kernel files and templates to write
 ufo filters

Package: libufo-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: gir1.2-ufo-1.0 (= ${binary:Version}),
         libglib2.0-dev,
         libjson-glib-dev,
         libpython3-dev,
         libufo1 (= ${binary:Version}),
         libzmq3-dev,
         ocl-icd-opencl-dev,
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Suggests: ufo-core-doc
Description: Library for high-performance, GPU-based computing - devel
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package contain the development files for libufo.

Package: ufo-core-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: Library for high-performance, GPU-based computing - documentation
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package provides the documentation for libufo.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --with gir,python3,sphinxdoc --without autoreconf --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DINSTALL_COMPLETION=ON -DWITH_SYSTEMD=ON

override_dh_install:
	# gir1.2-ufo-1.0
	dh_install -p gir1.2-ufo-1.0 usr/lib/*/girepository-1.0

	# libufo-bin
	dh_install -p libufo-bin usr/bin/ufo-*
	dh_install -p libufo-bin usr/share/man/man1/ufo-*
	dh_install -p libufo-bin usr/share/bash-completion

	# libufo-data
	dh_install -p libufo-data usr/share/ufo

	# libufo-dev
	dh_install -p libufo-dev usr/include/*
	dh_install -p libufo-dev usr/lib/*/lib*.so
	dh_install -p libufo-dev usr/lib/*/pkgconfig
	dh_install -p libufo-dev usr/share/gir-1.0/

	# libufo1
	dh_install -p libufo1 usr/lib/*/lib*.so.*

	# ufo-core-doc
	dh_install -p ufo-core-doc usr/share/gtk-doc
	dh_install -p ufo-core-doc ./*/docs/manual/html usr/share/doc/ufo-core-doc

	dh_install --remaining-packages

## ufo-core 0.16.0.90.gec8a707

=== debian/changelog ===
ufo-core (0.16.0.90.gec8a707-2) unstable; urgency=medium

  * dh_missing --list-missing

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sat, 22 Mar 2025 15:45:26 +0100

ufo-core (0.16.0.90.gec8a707-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Update standards version to 4.6.1, no changes needed.
  * Remove field Section on binary package libufo1 that duplicates source.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

  [ Serge Cohen ]
  * Merge KIT's newer version into the sources

  [ Picca Frédéric-Emmanuel ]
  Add missing build dependency on gobject-introspection-bin for addon gir.
  Replace XC-Package-Type with Package-Type.
  Remove unnecessary XS-Testsuite field in debian/control.
  Update standards version to 4.6.2, no changes needed.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sat, 22 Mar 2025 14:37:49 +0100

=== debian/control ===
--- 
+++ 
@@ -1,27 +1,34 @@
 Source: ufo-core
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Picca Frédéric-Emmanuel <picca@debian.org>,
+Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
+Uploaders:
+ Picca Frédéric-Emmanuel <picca@debian.org>,
+ Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>,
  Serge Cohen <serge1cohen@free.fr>,
- Alexandre Marie <alexandre.marie@synchrotron-soleil.fr>
+ Alexandre Marie <alexandre.marie@synchrotron-soleil.fr>,
 Section: libs
 Priority: optional
-Build-Depends: asciidoc,
-               bash-completion,
-               cmake,
-               debhelper-compat (= 12),
-               dh-python,
-               gobject-introspection,
-               gtk-doc-tools,
-               libgirepository1.0-dev,
-               libglib2.0-dev,
-               libjson-glib-dev,
-               libzmq3-dev,
-               ocl-icd-opencl-dev,
-               python3-dev,
-               python3-sphinx,
-               python3-sphinx-rtd-theme,
-Standards-Version: 4.5.0
+Build-Depends:
+ debhelper-compat (= 13),
+ dh-python,
+ dh-sequence-gir,
+ dh-sequence-python3,
+ dh-sequence-sphinxdoc <!nodoc>,
+ asciidoc,
+ bash-completion,
+ cmake,
+ gobject-introspection,
+ gobject-introspection-bin,
+ gtk-doc-tools,
+ libgirepository1.0-dev,
+ libglib2.0-dev,
+ libjson-glib-dev,
+ libzmq3-dev,
+ ocl-icd-opencl-dev,
+ python3-dev,
+ python3-sphinx,
+ python3-sphinx-rtd-theme,
+ python3-sphinxcontrib.bibtex,
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/ufo-core
 Vcs-Git: https://salsa.debian.org/science-team/ufo-core.git
 Homepage: http://ufo.kit.edu/
@@ -30,8 +37,12 @@
 Architecture: any
 Multi-Arch: same
 Section: introspection
-Depends: ${gir:Depends}, ${misc:Depends}, ${shlibs:Depends}
-Pre-Depends: ${misc:Pre-Depends}
+Depends:
+ ${gir:Depends},
+ ${misc:Depends},
+ ${shlibs:Depends},
+Pre-Depends:
+ ${misc:Pre-Depends},
 Description: Library for high-performance, GPU-based computing - gir binding
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous
@@ -48,9 +59,12 @@
 Package: libufo1
 Architecture: any
 Multi-Arch: same
-Section: libs
-Depends: libufo-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
-Pre-Depends: ${misc:Pre-Depends}
+Depends:
+ libufo-data (= ${source:Version}),
+ ${misc:Depends},
+ ${shlibs:Depends},
+Pre-Depends:
+ ${misc:Pre-Depends},
 Description: Library for high-performance, GPU-based computing - runtime
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous
@@ -65,8 +79,12 @@
 
 Package: libufo-bin
 Architecture: any
-Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
-Suggests: ufo-core-doc
+Depends:
+ ${misc:Depends},
+ ${python3:Depends},
+ ${shlibs:Depends},
+Suggests:
+ ufo-core-doc,
 Description: Library for high-performance, GPU-based computing - tools
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous
@@ -82,7 +100,8 @@
 Package: libufo-data
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
+Depends:
+ ${misc:Depends},
 Description: Library for high-performance, GPU-based computing - data
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous
@@ -100,16 +119,19 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: gir1.2-ufo-1.0 (= ${binary:Version}),
-         libglib2.0-dev,
-         libjson-glib-dev,
-         libpython3-dev,
-         libufo1 (= ${binary:Version}),
-         libzmq3-dev,
-         ocl-icd-opencl-dev,
-         ${misc:Depends}
-Pre-Depends: ${misc:Pre-Depends}
-Suggests: ufo-core-doc
+Depends:
+ gir1.2-ufo-1.0 (= ${binary:Version}),
+ libglib2.0-dev,
+ libjson-glib-dev,
+ libpython3-dev,
+ libufo1 (= ${binary:Version}),
+ libzmq3-dev,
+ ocl-icd-opencl-dev,
+ ${misc:Depends},
+Pre-Depends:
+ ${misc:Pre-Depends},
+Suggests:
+ ufo-core-doc,
 Description: Library for high-performance, GPU-based computing - devel
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous
@@ -126,7 +148,9 @@
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: ${misc:Depends}, ${sphinxdoc:Depends}
+Depends:
+ ${misc:Depends},
+ ${sphinxdoc:Depends},
 Description: Library for high-performance, GPU-based computing - documentation
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous

## ufo-core 0.17.0.20.gd3d8998

=== debian/changelog ===
ufo-core (0.17.0.20.gd3d8998-1) unstable; urgency=medium

  [ Serge Cohen ]
  * New upstream version 0.17.0.20.gd3d8998
  * Corrected the library so version number
 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 29 Apr 2025 16:13:34 +0200

ufo-core (0.17.0.19.gdcddfe8-1) unstable; urgency=medium

  [ Serge Cohen ]
  * New upstream version 0.17.0.19.gdcddfe8
  * Added autopkgtest tests.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sat, 26 Apr 2025 16:01:16 +0200

=== debian/control ===
--- 
+++ 
@@ -83,8 +83,10 @@
  ${misc:Depends},
  ${python3:Depends},
  ${shlibs:Depends},
+ python3-numpy,
+ python3-jinja2
 Suggests:
- ufo-core-doc,
+ ufo-core-doc
 Description: Library for high-performance, GPU-based computing - tools
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous

=== debian/tests/control ===
Test-Command: ufo-launch --version
Depends: libufo-bin

Test-Command: ufo-runjson --version
Depends: libufo-bin

Test-Command: ufo-query --list --verbose
Depends: libufo-bin

Test-Command: ufo-mkfilter --help
Depends: libufo-bin

Test-Command: ufo-prof --help
Depends: libufo-bin

## ufo-core 0.17.0.22.gc831aec

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 cmake_policy(SET CMP0054 OLD)
 endif ()
 
-project(ufo C)
+project(ufo)
 
 set(TARNAME "libufo")
 
@@ -45,8 +45,9 @@
 
 #}}}
 #{{{ Options
-option(WITH_TESTS "Build test suite" ON)
+option(WITH_TESTS "Build test suite" OFF)
 option(WITH_DEPRECATED_OPENCL_1_1_API "Build with deprecated OpenCL 1.1 API" ON)
+set(UFO_MAX_INPUT_NODES "64" CACHE STRING "Maximum number of allowed input nodes for a task")
 
 if (WITH_DEPRECATED_OPENCL_1_1_API)
     add_definitions ("-DCL_USE_DEPRECATED_OPENCL_1_1_APIS")

=== meson_options.txt ===
--- 
+++ 
@@ -9,3 +9,16 @@
 option('bashcompletiondir',
     type: 'string',
     description: 'directory for bash complection scripts ["no" disables]')
+
+option('ufo_max_input_nodes',
+    type: 'integer', value: 64,
+    description: 'Maximum number of allowed input nodes for a task')
+
+option('with_tests',
+    type: 'boolean', value: false,
+    description: 'Specifies if tests are build.')
+
+option('python',
+    type : 'string',
+    value : 'python3',
+    description : 'Name of python executable')

=== docs/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

find_program(SPHINX sphinx-build PATHS /usr/local/bin /usr/bin)
find_program(A2X NAMES a2x a2x.py)
mark_as_advanced(SPHINX)
mark_as_advanced(A2X)

# --- End-user manual ---------------------------------------------------------
if(SPHINX)
    option(WITH_MANUAL "Build user manual" ON)

    if (WITH_MANUAL)
        set(input_dir ${CMAKE_CURRENT_SOURCE_DIR}/manual)
        set(output_dir ${CMAKE_CURRENT_BINARY_DIR}/manual/html)

        file(GLOB_RECURSE sphinx_source ${input_dir}/*.rst)
        
        foreach(file ${sphinx_static})
            configure_file(${input_dir}/${file} ${output_dir}/${file} COPYONLY)
        endforeach()

        add_custom_command(OUTPUT ${output_dir}/index.html
            COMMAND ${SPHINX} -b html ${input_dir} ${output_dir}
            DEPENDS ${sphinx_source}
            COMMENT "Build Sphinx HTML")

        add_custom_target(manual ALL DEPENDS ${output_dir}/index.html)

        add_dependencies(manual ufo)
    endif()
endif()

# --- Manpages # --------------------------------------------------------------
if (A2X)
    option(WITH_MANPAGES "Build manpages" ON)

    if (WITH_MANPAGES)
        set(MAN_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/man)
        set(MAN_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR}/man/man1)

        file(MAKE_DIRECTORY ${MAN_BUILD_DIR})

        set(A2X_OPTS
            -L
            -D ${MAN_BUILD_DIR}
            -d manpage
            -f manpage
            )

        set(MAN_NAMES
            ufo-launch.1
            ufo-mkfilter.1
            ufo-query.1
            ufo-prof.1
            ufo-runjson.1
            )

        set(MAN_FILES)

        foreach(m IN LISTS MAN_NAMES)
            set(mf ${MAN_BUILD_DIR}/${m})
            set(ms ${MAN_SOURCE_DIR}/${m}.txt)

            add_custom_command(OUTPUT ${mf}
                COMMAND ${A2X} ${A2X_OPTS} ${ms}
                DEPENDS ${ms}
                COMMENT "Building manpage ${m}"
                VERBATIM)

            list(APPEND MAN_FILES ${mf})
            install(FILES ${mf} DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
        endforeach()

        add_custom_target(man ALL DEPENDS ${MAN_FILES})
    endif ()
endif ()

=== tests/unit/CMakeLists.txt ===
--- 
+++ 
@@ -6,11 +6,16 @@
     test-graph.c
     test-node.c
     test-profiler.c
+    test-max-input-nodes.cpp
     )
 
 set(SUITE_BIN "test-suite")
 
 add_executable(${SUITE_BIN} ${TEST_SRCS})
+
+set_property(TARGET ${SUITE_BIN} PROPERTY CXX_STANDARD 11)
+set_property(TARGET ${SUITE_BIN} PROPERTY CXX_STANDARD_REQUIRED ON)
+
 
 target_link_libraries(${SUITE_BIN} ufo m ${UFOCORE_DEPS})

=== debian/changelog ===
ufo-core (0.17.0.22.gc831aec-1) unstable; urgency=medium

  * Trying to make the package backportable to bookworm
  * New upstream version 0.17.0.22.gc831aec

 -- Serge Cohen <serge.cohen@cnrs.fr>  Sat, 10 May 2025 15:11:56 +0200

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
  bash-completion,
  cmake,
  gobject-introspection,
- gobject-introspection-bin,
+ gobject-introspection-bin | gobject-introspection,
  gtk-doc-tools,
  libgirepository1.0-dev,
  libglib2.0-dev,

=== debian/rules ===
--- 
+++ 
@@ -1,12 +1,9 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
-
-#export DH_VERBOSE=1
-export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 %:
-	dh $@ --with gir,python3,sphinxdoc --without autoreconf --buildsystem=cmake
+	dh $@ --without autoreconf --buildsystem=cmake
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DINSTALL_COMPLETION=ON -DWITH_SYSTEMD=ON
@@ -36,4 +33,7 @@
 	dh_install -p ufo-core-doc usr/share/gtk-doc
 	dh_install -p ufo-core-doc ./*/docs/manual/html usr/share/doc/ufo-core-doc
 
-	dh_install --remaining-packages
+	dh_install -a
+
+override_dh_missing:
+	dh_missing --list-missing
